/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

#include <string>
#include <iostream>

#include "toppers/oil/oil_parser.hpp"
#include "toppers/diagnostics.hpp"

using namespace std;
using namespace boost::spirit::classic;
using namespace toppers::oil;
using namespace toppers::oil::oil_implementation;
using namespace toppers::oil::oil_definition;


int oil_parser::do_parse(oil_impl **impl , oil_def **def)
{
	oil_grammer grammer(this);
	parse_info<> info;
	
	info = parse(description->c_str() , grammer , space_p);
	if(info.hit)
	{
		*impl = &impl_list;
		*def = &def_list;
		return 0;
	}
	else
	{
		return -1;
	}
}

void eval_tree(tree_match<char const *>::tree_iterator const &iter, int nest) {
	int size; // ΡɤλҤθĿ
	
	size = iter->children.size(); // ΡɤλҤθĿФ
	for(int i=0; i<nest; i++)
	{
		cout << "  "; // ڡʬǥ
	}
	cout << "Node = '" << string(iter->value.begin(), iter->value.end()) << "'";
	if (size > 0)
	{
		cout << " Child Size = " << size << endl; // ҤθĿɽ
	} else
	{
		cout << endl;                             // Ҥ̵иĿɽʤ
	}
	for(int j=0; j<size; j++)
	{
		eval_tree(iter->children.begin()+j, nest+1); // ҤθĿʬƵƤӽФ
	}
}

int oil_parser::start_objimpl_analysis(std::string object_name)
{
	int result = 0;

	try
	{
		// Υ֥ȼ¸
		current_impl = new oil_object_impl(object_name);
	}
	catch( ... )
	{
		result = -1;
	}
	
	return result;
}

int oil_parser::set_nextparam_name(std::string name)
{
	if(param_addable == true)
	{
		next_param_name = name;
	}

	return 0;
}

int oil_parser::add_parameter_objimpl(std::string parameter)
{
	// ѥ᡼ϡɲ
	if(param_addable)
	{
		current_impl->add_parameter(next_param_name , parameter);
	}

	return 0;
}

int oil_parser::start_objdef_analysis(std::string object_name_type)
{
	int result = 0;

	try
	{
		// Υ֥ȼ¸
		current_def = new object_definition(object_name_type);
	}
	catch( ... )
	{
		result = -1;
	}
	return result;
}

int oil_parser::end_objimpl_analysis(void)
{
	// λϿ
	impl_list.push_back(current_impl);
	
	return 0;
}

void oil_parser::enable_addparam(bool enabled)
{
	param_addable = enabled;
}

int oil_parser::end_objdef_analysis(void)
{
	static std::vector<std::string> defined_object_name;
	std::string obj_name = current_def->get_name();

	// Ʊ֥Ȥʤå
	if(find(defined_object_name.begin() , defined_object_name.end() , obj_name)
			== defined_object_name.end())
	{
		// λϿ
		def_list.push_back(current_def);
		// ֥̾ɲáϿѤߤˤ
		defined_object_name.push_back(obj_name);
	}
	else
	{
		// Ʊ̾Υ֥̾¸ߤ뤿ᡤ顼
		toppers::error("Object %1% redefined." , obj_name);
	}
	
	return 0;
}

int oil_parser::add_attr_value(string str)
{
	attr_description = str;

	if(param_addable == true)
	{
		current_def->add_parameter(next_param_name , attr_description);
	}

	return 0;
}

void oil_parser::set_error(int position , std::string message)
{
	error_position = position;
	error_message = message;
}

void oil_parser::get_error(int *position , std::string *message)
{
	*position = error_position;
	*message = error_message;
}

void oil_parser::dump_implementation(void)
{
	std::vector<oil_object_impl*>::iterator p;

	for(p = impl_list.begin(); p != impl_list.end() ; p++)
	{
		(*p)->display_implementation();
	}
}

void oil_parser::dump_definition(void)
{
	std::vector<object_definition*>::iterator p;
	
	cout << "************** Object Defition **************" << endl;
	for(p = def_list.begin(); p != def_list.end() ; p++)
	{
		(*p)->display_definition();
	}
	cout << "************** Object Defition End **************" << endl;
}
